<style lang="scss" scoped>
.search-bar {
  display: flex;
  align-items: center;
}
.search-box p {
  display: inline-block;
  border: 1px solid #f2f2f2;
  border-radius: 5px;
  margin-right: 10px;
  padding: 5px 10px;
  cursor: pointer;
}
</style>
<style>
/* .data-display-statistics .ant-card-body {
  padding: 0 15px;
} */
.data-display-statistics .ant-col-6 {
  margin: 10px 0;
}
.data-display-statistics .ant-col-6 .ant-card-body {
  display: flex;
  justify-content: center;
}
.data-display-statistics .ant-col-6 p,
.data-display-statistics .ant-col-6 span {
  text-align: center;
  line-height: 40px;
  font-size: 30px;
  font-weight: 600;
  color: red;
  margin: 0;
}
.search-box .ant-card-body {
  padding: 5px 15px;
}
.data-display-statistics .ant-col-6 .ant-card-body .styleElse {
  line-height: 60px;
  height: 40px;
  font-size: 16px;
  font-weight: 400;
  margin-left: 10px;
}
.ant-modal-wrap .yincang .ant-modal-content .ant-modal-footer {
  display: none !important;
}
.yincang .ant-col-6 p {
  text-align: left;
  color: red;
  font-size: 16px;
  font-weight: 500;
}
.ant-table-thead div {
  font-weight: 700;
}
.tool-tip {
  position: absolute;
  top: 65px;
  right: 10px;
}
th div {
  white-space: nowrap;
}
</style>
<template>
  <div class="data-statistics">
    <a-row class="image-list-heading vm-panel">
      <a-row type="flex" align="middle" justify="space-between" class="panel-body">
        <div class="search-bar" style="width:100%">
          <span>账户选择：</span>
          <a-select
            v-model="projectId"
            style="width:500px"
            showSearch
            optionFilterProp="children"
            :filterOption="filterOption"
          >
            <a-select-option :value="item.projectId" v-for="item of dataElse" :key="item.projectId">
              {{ item.projectName }}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{{ item.advertiserName }}
            </a-select-option>
          </a-select>
          <span style="margin-left:10px">日期选择：</span>
          <a-date-picker v-model="statDate" format="YYYY-MM-DD" />
          <span style="margin-left:10px">返点比例：</span>
          <a-input-number
            :min="1"
            :max="10"
            :step="0.01"
            v-model="discount"
            placeholder="请输入折扣"
            style="width:100px"
          />

          <a-button type="primary" style="margin:10px" @click="addUser">搜索</a-button>
          <a-button
            type="primary"
            icon="reload"
            @click="getDataReset"
            style="background-color:#67c23a;border-color:#67c23a"
            >刷新</a-button
          >
        </div>
      </a-row>
    </a-row>
    <a-row :gutter="10" style="margin-top:10px">
      <a-col :span="24">
        <a-card
          style="width:100%"
          :tabList="tabListNoTitle"
          :activeTabKey="noTitleKey"
          @tabChange="key => onTabChange(key, 'noTitleKey')"
        >
          <div style="display:flex;margin-bottom:15px">
            <!-- <a-select style="width: 120px" v-model="statHour" @change="getElseData" allowClear>
              <a-select-option v-for="item of 24" :key="item - 1" :value="item - 1">{{ item - 1 }}</a-select-option>
            </a-select> -->
            <a-button type="primary" @click="exportExcel">导出</a-button>
          </div>
          <a-table
            size="middle"
            :columns="columns"
            :dataSource="data"
            bordered
            id="outTable"
            :pagination="false"
            :scroll="{ x: true }"
            :loading="loading"
          >
          </a-table>
        </a-card>
      </a-col>
    </a-row>
  </div>
</template>

<script>
import ARow from 'ant-design-vue/es/grid/Row'
import ACol from 'ant-design-vue/es/grid/Col'
import countTo from 'vue-count-to'
import moment from 'moment'
import { getDailyReport } from '@api/statistics'
import { getAction, postAction, downFile, downFilePost } from '@/api/manage'
import axios from 'axios'
import lifting from '../components/lifting'
import timeCheck from '../components/timeCheck'
import Treeselect from '../components/Treeselect.vue'
import { mapGetters } from 'vuex'
// import { JeecgListMixin } from '@/mixins/ipagination'

var length = 0
var active = 1
const columns = [
  {
    title: '投放设备',
    dataIndex: 'systemType',
    scopedSlots: { customRender: 'systemType' },
    align: 'center'
  },
  {
    title: '分类',
    dataIndex: 'authName',
    scopedSlots: { customRender: 'authName' },
    align: 'center'
  },
  {
    title: '现金花费',
    dataIndex: 'charge',
    align: 'center'
  },
  {
    title: '账户激活量',
    dataIndex: 'activation',
    align: 'center'
  },
  {
    title: '激活成本',
    dataIndex: 'activationCost',
    align: 'center',
    scopedSlots: { customRender: 'activationCost' }
  },
  // {
  //   title: '预估成本',
  //   dataIndex: 'estimatedCost',
  //   align: 'center',
  //   scopedSlots: { customRender: 'estimatedCost' }
  // }
]

const columnsGroup = columns

export default {
  name: 'data-display-statistics',
  components: {
    ACol,
    ARow,
    countTo,
    lifting,
    timeCheck,
    Treeselect
  },
  // mixins: [JeecgListMixin],
  data: function() {
    return {
      statDate: moment(new Date()),
      title: '账户数据展示',
      show: true,
      data: [],
      dataAll: null,
      columns: columns,
      options: [],
      list: [],
      appId: [],
      tabListNoTitle: [
        {
          key: 'day',
          tab: '安卓'
        },
        {
          key: 'group',
          tab: 'ios'
        }
      ],
      noTitleKey: 'day',
      discount: 1.06,
      date: '',
      loading: false,
      dataElse: [],
      projectId: 50
    }
  },
  filters: {
    formatDate: function(value) {
      let date = new Date(value)
      let y = date.getFullYear()
      let MM = date.getMonth() + 1
      MM = MM < 10 ? '0' + MM : MM
      let d = date.getDate()
      d = d < 10 ? '0' + d : d
      let h = date.getHours()
      h = h < 10 ? '0' + h : h
      let m = date.getMinutes()
      m = m < 10 ? '0' + m : m
      let s = date.getSeconds()
      s = s < 10 ? '0' + s : s
      return y + '-' + MM + '-' + d
    },
    toFixtwo: function(value) {
      if (value) {
        return value.toFixed(2)
      } else {
        return 0.0
      }
    },
    getBo: function(value) {
      if (value) {
        return (value * 100).toFixed(2) + '%'
      } else {
        return '0.00%'
      }
    }
  },
  methods: {
    moment,
    filterOption(input, option) {
      return option.componentOptions.children[0].text.toLowerCase().indexOf(input.toLowerCase()) >= 0
    },
    ...mapGetters(['nickname', 'avatar', 'userInfo']),
    getParticipateList() {
      postAction('/ctop/projectMember/participateListByMediaId', {
        userId: this.userInfo().id,
        type: "kuaishou"
      }).then(res => {
        if (res.success) {
          this.dataElse = res.result
        }
      })
    },
    onTabChange(key, type) {
      console.log(key, type)
      this[type] = key
      this.data = []
      if (key == 'day') {
        this.columns = columns
        this.data = this.dataAll.android.map((item, index) => {
          return {
            ...item,
            key: index
          }
        })
      } else {
        this.columns = columnsGroup
        this.data = this.dataAll.ios.map((item, index) => {
          return {
            ...item,
            key: index
          }
        })
      }
      // this.ipagination.total = this.data.length
      // this.ipagination.current = 1
    },
    disabledDate(current) {
      return current && current > moment().subtract(1, 'day')
    },
    getDataReset() {
      this.addUser()
    },
    addUser() {
      var that = this
      //   if (this.appId.length > 0 && this.date != '') {
      that.getDailyReport()
      //   } else {
      //     this.$message.error('请选择账户及时间')
      //   }
    },
    getDailyReport() {
      var params = {}
      params.projectId = this.projectId
      params.disCount = this.discount
      params.statDate = this.statDate.format('YYYY-MM-DD')
      this.data = []
      this.loading = true
      postAction('/ctop/yiche/report/hourReport', params).then(res => {
        if (res.success) {
          this.loading = false
          this.dataAll = res.result
          console.log(res)
          if (this.noTitleKey == 'day') {
            if (res.result.android) {
              this.data = res.result.android.map((item, index) => {
                return {
                  ...item,
                  key: index
                }
              })
            } else {
              this.data = []
            }
          } else {
            if (res.result.ios) {
              this.data = res.result.ios.map((item, index) => {
                return {
                  ...item,
                  key: index
                }
              })
            } else {
              this.data = []
            }
          }
          // this.ipagination.total = this.data.length
        }
      })
    },
    getDate(value) {
      if (value) {
        let date = new Date(value)
        let y = date.getFullYear()
        let MM = date.getMonth() + 1
        MM = MM < 10 ? '0' + MM : MM
        let d = date.getDate()
        d = d < 10 ? '0' + d : d
        this.date = y + '-' + MM + '-' + d
      } else {
        let date = new Date()
        let y = date.getFullYear()
        let MM = date.getMonth() + 1
        MM = MM < 10 ? '0' + MM : MM
        let d = date.getDate()
        d = d < 10 ? '0' + d : d
        this.date = y + '-' + MM + '-' + d
      }
    },
    exportExcel() {
      var params = {}
      params.projectId = this.projectId
      params.disCount = this.discount
      params.statDate = this.statDate.format('YYYY-MM-DD')
      var name = this.dataElse.filter(item => {
        return item.projectId == this.projectId
      })[0].projectName
      downFilePost('/ctop/yiche/report/exportHourReport', params).then(res => {
        let blob = new Blob([res], {
          type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
        })
        let downloadElement = document.createElement('a')
        let href = window.URL.createObjectURL(blob) //创建下载的链接
        downloadElement.href = href
        downloadElement.download = name + '-时报' //下载后文件名
        document.body.appendChild(downloadElement)
        downloadElement.click() //点击下载
        document.body.removeChild(downloadElement) //下载完成移除元素
        window.URL.revokeObjectURL(href) //释放掉blob对象
      })
    }
  },
  watch: {},
  distoryed() {},
  mounted: function() {
    this.getParticipateList()
  }
}
</script>
